;**************************************************************************************************************************
; Thermo2.asm
;  LCD-  2-  DS18B20. 
;      . 
;-------------------------------------------------------------------------------------------------------------------------
; !!!!!         - ,
;   PCL     "Fraction"       !!!!!!!!!!!!!!
;--------------------------------------------------------------------------------------------------------------------------
; PIC16F873A       4 .
;=============================================================================================================================
            LIST        p=16F873A    
            __CONFIG    03F71H      ;   , WDT , 
                                    ;  XT - ,   
; .       , ,   
; PORTB LCD    ,    PORTB,RB3.

          #INCLUDE   <P16F873A.INC>
;============================================================================================================================

;  pp STATUS
C	    	EQU    	0h
DC	    	EQU    	1h
Z		    EQU    	2h
PD		    EQU		3h
TO		    EQU    	4h
RP0		    EQU    	5h
RP1		    EQU		6h

;   PORTC

RS	        EQU     04h            ;
E           EQU     05h  


;   PORTC
DQ          EQU     06h            ;   1
DQ2         EQU     07h            ;   2
;   

TEMP        EQU     20h
TEMPh       EQU     21h
TEMPl       EQU     22h
Place       EQU     23h
Count       EQU     24h
Count1      EQU     25h
Count2      EQU     26h
KeyCode     EQU     27h            ;     ,    LCD
Dec         EQU     28h
Bufer       EQU     29h            ;   ()  DS1820
Bufer_L     EQU     2Ah            ;    
Bufer_H     EQU     2Bh            ;    
RegFloor    EQU     2Ch            ;     
RegCopy     EQU     2Dh            ;  RegFloor 

BIN0        EQU     30h            ;    
                                   ; 1- - .
BIN1        EQU     31h            ; ------- 2- -------------------------
 
Mem         EQU     32h            ;   .
Bufer2      EQU     33h

F           EQU     1h
W           EQU     0h

            ORG     0
            GOTO    START
;=============================================================================================================================

START

 ;------- -------------------------------------------------------------------------------------------

      clrf         OPTION_REG
      clrf         INTCON           ;  
     ;clrf         PORTA            ;   
      clrf         PORTC            ;   
      clrf         PORTB            ;   B
      bsf		   STATUS,RP0 	    ;   1
      bcf          STATUS,RP1
      movlw        b'0110'
      movwf        ADCON1           ;    -  \ ( )
     ;clrf         TRISA            ;    
	  clrf	       TRISB		    ;    
      movlw        b'00001111'
      movwf        TRISC            ; RC0-RC3  ,   
      bcf		   STATUS,RP0	    ;   0
      bcf          STATUS, Z
      clrf         KeyCode
    
      call        LCD_Init          ;  
      
;---------------    -----------------------------------------------

      movlw       h'54'                    ;  ""
      call        Lcd_Write_Data
      movlw       h'31'                    ;  "1"
      call        Lcd_Write_Data           
  
      movlw       b'10000000'+ 40h         ;     
      call        Lcd_Write_Cmd

      movlw       h'54'                    ;  ""
      call        Lcd_Write_Data
      movlw       h'32'                    ;  "2"
      call        Lcd_Write_Data

      ;call       Delay_3s
;==========================================================================================================
;---------------   DS18B20-------------------------------------------------------------------
;===========================================================================================================
;    DS18B20,  , :
;1)  -  0   480,  1   480.  
;2)  Skip ROM (CCh)-     ,     .
;3)  Start Conv (44h)-    .
;4)   .
;5) .
;6) Skip ROM.
;7)  "Read_Scratchpad"(BEh) -     .
;8)       LCD.
;9)   .1)
;-------------------------------------------------------------------------------------------------------------
Thermo:

      call       DQ_Init                    ;   
      call       DQ2_Init                   ;    2- 
                                          
      movlw      h'CC'                      ;  "Skip_ROM"(h) -     ,                    
      movwf      Bufer                      ;,   
      call       Out_Byte
      
      movlw      h'CC'                      ;    2-                   
      movwf      Bufer2                 
      call       Out_Byte2  
                                          
      movlw      h'44'                      ;   "Start_Conv"(44h) -         
      movwf      Bufer             
      call       Out_Byte
      
      movlw      h'44'                      ;    2-    
      movwf      Bufer2             
      call       Out_Byte2
   
Wait:                                       ;   ,       1
      call       In_Byte2
      movlw      b'11111111'                ; ..  Bufer   ,    Z
      subwf      Bufer2,W                   ;     , .. 1-   
      btfss      STATUS,Z
      goto       Wait
;----- 
      call       DQ_Init                    ;    "Skip_ROM"
      call       DQ2_Init

      movlw      h'CC'                      ;
      movwf      Bufer
      call       Out_Byte 
      
      movlw      h'CC'                      ;
      movwf      Bufer2
      call       Out_Byte2    

      movlw      h'BE'                      ;   "Read_Scratchpad"(BEh) -     
      movwf      Bufer  
      call       Out_Byte
      
      movlw      h'BE'                      ;    2- 
      movwf      Bufer2  
      call       Out_Byte2

;-----   1- ---
      
      call       In_Byte                    ;    
      movwf      Bufer_L                    ;     Bufer_L
     
      call       In_Byte                    ;    
      movwf      Bufer_H                    ;  c   Bufer_H
;-----               
      call       Display                    ;    LCD

;-----   2- ---


      call         In_Byte2                 ;    
      movwf        Bufer_L                  ;     Bufer_L

      call         In_Byte2                 ;    
      movwf        Bufer_H                  ;  c   Bufer_H
;----- 

      movlw        b'10000000'+ h'42'       ;   
      call         Lcd_Write_Cmd              
      call         Display2
    
      goto         Thermo

    
;==============================================================================================================
;==============   ====================================================================================
; DS1820 "DQ_Init"--------------------------------------------------------------------------------------------

DQ_Init:                                   ;   (     ):
                                           ; 1)  DQ 0   480-960 
                                           ; 2)""  DQ ( RC6    )    480 

       bsf         STATUS, RP0             ;    
       bsf         TRISC, DQ               ;  DQ(RC6)  ,   DQ  1 ( ,   "")
       bcf         STATUS, RP0             ;   0- .
       
       bcf         PORTC, DQ               ;  0  DQ
       bsf         STATUS, RP0             ;   1- 
       bcf         TRISC, DQ               ; RC6  
       bcf         STATUS, RP0

      ; movlw       .98                     ;  900  (300+600)
      ; call        Delay_x
       movlw       .198
       call        Delay_x
       
       bsf         STATUS, RP0
       bsf         TRISC, DQ               ;  DQ(RC6)  ,   DQ  1
       bcf         STATUS, RP0

       movlw        .198                    ;  600 
       call         Delay_x

       return   

;-------------------------------------------------------------------------------------------------------------------------    
;    "Out_Byte":
;     1-Wire      1-15 ,
;    (   60 ).        1 .

Out_Byte:
      movlw        .8                      ;       
      movwf         Count
 lable1:
      rrf           Bufer,F                ;    

      btfss         STATUS,C               ;    0  1
      goto          Out_0                  ;  0
      goto          Out_1                  ;  1
 lable2:
      decfsz        Count,F                ;         
      goto          lable1

      return  

;---------------------------------------------------------------------------------------------------------------------------
;   0 "Out_0 ":

Out_0:
      bcf          PORTC,DQ                ;  0  DQ.     0, ..     
      bsf          STATUS,RP0              ;  1 ( )
      bcf          TRISC,DQ                ;  RC6  .
      bcf          STATUS,RP0 
  
      movlw        .18                     ;     60 . 
      call         Delay_x
      nop                                  ;         60 .

      bsf          STATUS, RP0             ;  1 (  RC6   -  )
      bsf          TRISC, DQ
      bcf          STATUS, RP0

      goto         lable2   

;----------------------------------------------------------------------------------------------------------------------------
;   1 "Out_1 ":

Out_1:    
     bcf          PORTC,DQ                ;   1,   0,   (  1)
     bsf          STATUS,RP0              ; ..     ( )
     bcf          TRISC, DQ
     bcf          STATUS,RP0

     bsf          STATUS,RP0              ;  1  DQ,   RC6     ( )
     bsf          TRISC,DQ
     bcf          STATUS,RP0

     movlw        .18                    
     call         Delay_x                 ;         60 .

     goto         lable2   



;-----------------------------------------------------------------------------------------------------------------------------
;    "In_Byte"

In_Byte:
     movlw         .8                        ;    
     movwf         Count
     clrf          Bufer
In_Byte_1:                                   ;      (0-1)
     bcf           PORTC,DQ                  ;  0
     bsf           STATUS,RP0
     bcf           TRISC,DQ
     bcf           STATUS, RP0

     bsf           STATUS,RP0                ;  1
     bsf           TRISC,DQ
     bcf           STATUS,RP0
     nop
                                             ;       
     btfss         PORTC,DQ                  ;   0  1?
     bcf           STATUS,C                  ;    0,     0
     btfsc         PORTC,DQ                  ;    1,      1
     bsf           STATUS,C 

     rrf           Bufer,F                   ;  Bufer   
     movlw         .12                       ;   40 
     call          Delay_x    

     decfsz        Count,F
     goto          In_Byte_1
     movf          Bufer,W

     return

;-------------------------------------------------------------------------------------------------------------
;         LCD "Display".  :
;1)    
;2)    "+"  "-".    8-    .(Bufer_h,7)
;3) ""       RegFloor    .
;4)     -.
;5)  1,      100
;6) Ec   10,   (   0)  .
;7)     
;8)     0,1   .
;

Display:
     movlw       b'10000000'+ h'2'              ;   
     call        Lcd_Write_Cmd

Display2:
;-----  ---  
  
     btfsc       Bufer_H,7                ;  1,  "-",  0,  "+"
     goto        Minus
     goto        Plus

;---   ---

;   ( ,  )   c       
;  .         RegFloor ,   .  
Floor:
     clrf        RegFloor
     movfw       Bufer_L                  ;  Bufer_L   RegFloor
     movwf       RegFloor
     swapf       RegFloor,F               ;      ,  ,   4 
                                          ;      RegFloor
                                          ;     3      Bufer_H  RegFloor                                    ;  RegFloor
   
     btfsc       Bufer_H,0                ;  0-  Bufer_H  1,  1  4-  RegFloor   ,  0,   
     bsf         RegFloor,4
     btfss       Bufer_H,0                ;  0-  Bufer_H  0,  0  4-  RegFloor   
     bcf         RegFloor,4

     btfsc       Bufer_H,1                ;   1- 
     bsf         RegFloor,5
     btfss       Bufer_H,1
     bcf         RegFloor,5

     btfsc       Bufer_H,2                ;   2- 
     bsf         RegFloor,6
     btfss       Bufer_H,2
     bcf         RegFloor,6

     bcf         RegFloor,7               ; 3-    (  ),    .

   
     movfw       RegFloor                 ;   RegCopy
     movwf       RegCopy


;      ,    ,   RegFloor;
;      - ,    Bin2_10

     call        Bin2_10

;   BIN1    ,  BIN0 - 

     call        Display_x99;              ;   LCD 2-    

;--- ","   ----

     movlw       h'2C'
     call        Lcd_Write_Data

;---   ----
    
     bcf         Bufer_L,7                  ; .         ,
     bcf         Bufer_L,6                  ;   .
     bcf         Bufer_L,5
     bcf         Bufer_L,4                   

     movf        Bufer_L,W      
     call        Fraction                   ;     .

     call        Lcd_Write_Data
     
     movlw       h'20'
     call        Lcd_Write_Data 
  
    
Fraction:
     addwf        PCL,F
     retlw        h'30'
     retlw        h'31'
     retlw        h'31'
     retlw        h'32'
     retlw        h'33'
     retlw        h'33'
     retlw        h'34'
     retlw        h'34'
     retlw        h'35'
     retlw        h'36'
     retlw        h'36'
     retlw        h'37'
     retlw        h'37'
     retlw        h'38'
     retlw        h'39'
     retlw        h'39'
    
;--------------------------------------------------------------------------------------------------------------
;   "-" 
Minus:
     movlw       h'2D'                   ;  "-"
     call        Lcd_Write_Data

     comf        Bufer_L,F               ;         1
     incf        Bufer_L,F

     comf        Bufer_H,F
              
     goto        Floor                   ;      

;--------------------------------------------------------------------------------------------------------------
;   "+"
Plus:
     movlw       h'2B'                   ;  "+"
     call        Lcd_Write_Data
     goto        Floor                   ;      

;-----------------------------------------------------------------------------------------------------------------
;      - "Bin2_10",   1-  .

Bin2_10:
     bcf         STATUS,C                ;   -.
     movlw       .8                      ;    Count   ,
     movwf       Count                   ;     = 8

     clrf        BIN0                  
     clrf        BIN1                   
    
;      .
         
Loop4: 
     rlf         RegFloor,F               ;      
           
     rlf         BIN0,F        

     decfsz      Count,F                  ;  (-1)   Count 
     goto        adjDEC                   ;   =0,     adjDEC
                                          ;    =0,    .
;     BIN0 ( )     BIN0  BIN1.

     swapf        BIN0,W                   ;    BIN0    BIN1.
     andlw        0Fh                     
     movwf        BIN1                    

     movfw        BIN0                     ;    BIN0    BIN0.
     andlw        0Fh                      
     movwf        BIN0                     
           
;  .       BIN0  BIN1 
; -     .   = 0.
     return  

;    FSR   LED0...3         adjBCD.
;     LED -    .                      

adjDEC   
     movlw       BIN0                     ;    FSR,   W,   BIN0
     movwf       FSR                      ;      adjBCD
     call        adjBCD                   ; (     ).
          
     goto        Loop4                

;       -:
;   LED0...3   03h,30h    3-  7- .

adjBCD  
     movlw        3                       ;    BIN (BIN0  BIN1)   03h,  
     addwf       0,W                      ; c   ,   W,
     movwf       Mem                      
  
     btfsc       Mem,3                    ;   3-   Mem.
     movwf       0                        ;    3 =1,    Mem 
                                          ;    BIN.

     movlw       30                       ;   3 =0,    BIN 
     addwf       0,W                      ;   30h,     ,  
     movwf       Mem                      ;   W,   Mem.

     btfsc       Mem,7                    ;   7-   Mem.
     movwf       0                        ;   7 =1,    Mem 
                                          ;    BIN.

     retlw       0                        ;   7 =0,   W   
                                          ;      adjDEC.

;-------------------------------------------------------------------------------------------------------------------
;    LCD 2-     "Display_99"

;     100
Display_x99:   
      movlw       .100                    ;   RegCopy .100,    (     100)
      subwf       RegCopy,W               ;      1.
      btfsc       STATUS,C
   
      goto        Display_1xx

; ,   0    (  0  10)
      movf       BIN1,F                   
      btfsc      STATUS,Z                ;   Z ,      ( 
      goto       Display_9               ; ,  ).

;  
Display_10:
      movlw      h'30'                   ;     30h (  0  LCD).
      iorwf      BIN1,W  
      call       Lcd_Write_Data

;  
Display_9
      movlw      h'30'
      iorwf      BIN0,W
      call       Lcd_Write_Data
     
      return    
   
;-------------------------------------------------------------------------------------------------------------------------
;    1    100 "Display_1xx":

Display_1xx:
      movlw      h'31'
      call       Lcd_Write_Data
   
      goto       Display_10               ;      .



;==============   ====================================================================================
;---------------------------------------------------------------------------------------------------------------------------
;   DS1820 "DQ2_Init"

DQ2_Init:                                   ;   (     ):
                                            ; 1)  DQ 0   480-960 
                                            ; 2)""  DQ ( RC6    )    480 

       bsf         STATUS, RP0              ;    
       bsf         TRISC, DQ2               ;  DQ(RC6)  ,   DQ  1 ( ,   "")
       bcf         STATUS, RP0              ;   0- .
       
       bcf         PORTC, DQ2               ;  0  DQ
       bsf         STATUS, RP0              ;   1- 
       bcf         TRISC, DQ2               ; RC6  
       bcf         STATUS, RP0

      ; movlw       .98                     ;  900  (300+600)
      ; call        Delay_x
       movlw       .198
       call        Delay_x
       
       bsf         STATUS, RP0
       bsf         TRISC, DQ2               ;  DQ(RC6)  ,   DQ  1
       bcf         STATUS, RP0

       movlw        .198                    ;  600 
       call         Delay_x

       return   

;-------------------------------------------------------------------------------------------------------------------------    
;    "Out_Byte2":
;     1-Wire      1-15 ,
;    (   60 ).        1 .

Out_Byte2:
      movlw        .8                       ;       
      movwf         Count
 lable12:
      rrf           Bufer2,F                ;    

      btfss         STATUS,C                ;    0  1
      goto          Out2_0                  ;  0
      goto          Out2_1                  ;  1
 lable22:
      decfsz        Count,F                 ;         
      goto          lable12

      return  


;---------------------------------------------------------------------------------------------------------------------------
;   0 "Out2_0 ":

Out2_0:
      bcf          PORTC,DQ2                ;  0  DQ.     0, ..     
      bsf          STATUS,RP0               ;  1 ( )
      bcf          TRISC,DQ2                ;  RC6  .
      bcf          STATUS,RP0 
  
      movlw        .18                      ;     60 . 
      call         Delay_x
      nop                                   ;         60 .

      bsf          STATUS, RP0              ;  1 (  RC6   -  )
      bsf          TRISC, DQ2
      bcf          STATUS, RP0

      goto         lable22   


;----------------------------------------------------------------------------------------------------------------------------
;   1 "Out2_1 ":

Out2_1:    
     bcf          PORTC,DQ2                 ;   1,   0,   (  1)
     bsf          STATUS,RP0                ; ..     ( )
     bcf          TRISC, DQ2
     bcf          STATUS,RP0

     bsf          STATUS,RP0                ;  1  DQ,   RC6     ( )
     bsf          TRISC,DQ2 
     bcf          STATUS,RP0

     movlw        .18                    
     call         Delay_x                   ;         60 .

     goto         lable22  
;-----------------------------------------------------------------------------------------------------------------------------
;    "In_Byte2"

In_Byte2:
     movlw         .8                        ;    
     movwf         Count
     clrf          Bufer2
In_Byte2_1:                                 ;      (0-1)
     bcf           PORTC,DQ2                ;  0
     bsf           STATUS,RP0
     bcf           TRISC,DQ2
     bcf           STATUS, RP0

     bsf           STATUS,RP0               ;  1
     bsf           TRISC,DQ2
     bcf           STATUS,RP0
     nop
                                            ;       
     btfss         PORTC,DQ2                ;   0  1?
     bcf           STATUS,C                 ;    0,     0
     btfsc         PORTC,DQ2                ;    1,      1
     bsf           STATUS,C

     rrf           Bufer2,F                  ;  Bufer   
     movlw         .12                       ;   40 
     call          Delay_x    

     decfsz        Count,F
     goto          In_Byte2_1
     movf          Bufer2,W

     return

;==============  ================================================================================================
;---------------------------------------------------------------------------------------------------------------------------
;  :

 LCD_Init:    
      movlw      .185
      call        Delay                    ;  100 ms
      movlw      b'00111000'               ;   8 .   3 .
      call       Lcd_Write_Cmd
      movlw      .58            
      call       Delay                     ;  10 ms
      movlw      b'00111000'               ;   8 
      call       Lcd_Write_Cmd
      movlw      .58              
      call       Delay                     ;   10 ms
      movlw      b'00111000'               ;   8 
      call       Lcd_Write_Cmd
      movlw      .20              
      call       Delay                     ;   5 ms
      movlw      b'00111000'               ;  8 , 2 , 5  8 
      call       Lcd_Write_Cmd
      movlw      .20
      call       Delay                     ;   5 ms
      movlw      b'00001100'               ; . ,  
      call       Lcd_Write_Cmd 
      movlw      .20
      call       Delay
      call       LCD_Clear                 ;    
      ;movlw	 b'00001111'    	       ;   
      ;call      Lcd_Write_Cmd  
      return
      
;--------------------------------------------------------------------------------------------------------------------
;  "Lcd_Write_Cmd" -   .
 Lcd_Write_Cmd:
; W -   . ,    R\W   ,
;   .
       movwf        PORTB                ;     
       bcf          PORTC,RS             ;  ""
       nop                               ;     R\S (set-up time RS and R/W to E)
       nop                               ;     40 
       bsf          PORTC,E              ;  
       nop
       nop 
       nop
       nop                               ;    
       bcf          PORTC,E              ;        .
       call         Delay_70Us           ;  70 .   .
       return
       
;--------------------------------------------------------------------------------------------------------------
;  "Lcd_Write_Data" -    .
Lcd_Write_Data:
; W -   . ,    R\W   ,
;   .
       movwf        PORTB                ;     
       bsf          PORTC,RS             ;  ""
       nop                               ;     R\S (set-up time RS and R/W to E)
       nop                               ;     40 
       bsf          PORTC,E              ;  
       nop
       nop                               ;    
       bcf          PORTC,E              ;        .
       call         Delay_70Us           ;  70 .   .
       return

;------------------------------------------------------------------------------------------------------------------
;   .
LCD_Clear:
      movlw      b'00000001'              ;  
      call       Lcd_Write_Cmd
      movlw      .20
      call       Delay                    ;   5 ms
      movlw      b'10000000'              ;   DDRAM = 0 ( ,  )
      call       Lcd_Write_Cmd
      movlw      .20
      call       Delay
      return
      

;============================================================================================================
;--------------------------------------------------------------------------------------------------------------------
;   "Delay"
Delay:
       movwf        TEMPh        
 Cycle:
       movwf        TEMP
 Cycle_1:
       decfsz       TEMP,F       
       goto         Cycle_1    
       decfsz       TEMPh,F      
       goto         Cycle       
       return                            ;   .
;----------------------------------------------------------------------------------------------------------------------
;   "Delay_70Us"

Delay_70Us:
       movlw        .25       
       movwf        TEMP         
 Cycle_70Us:
       decfsz       TEMP,F       
       goto         Cycle_70Us    
       return                           ;   .

;---------------------------------------------------------------------------------------------------------------------------
;   "Delay_x"

Delay_x:       
       movwf        TEMP         
 Cycle_x:
       decfsz       TEMP,F       
       goto         Cycle_x    
       return                           ;   .
 



 END


